!====================================================================
! file fft_int.f90
!====================================================================
!         EFFECTIVE METHODS FOR SOLVING BANDED TOEPLITZ SYSTEMS
!                     by D.A. Bini and B. Meini
!               (bini@dm.unipi.it    meini@dm.unipi.it)
!           Fortran 90 Program version 1.0, October 30, 1997
!--------------------------------------------------------------------
!                   S C A L A R        C A S E
!====================================================================
!                           FFTs INTERFACES
!====================================================================
! This file contains modules and interfaces needed by the subroutines
! in the file fft_bt.f90
!====================================================================
MODULE fft_interface
  INTERFACE 
     SUBROUTINE iffts1(u,v)
       IMPLICIT NONE
       REAL(KIND(0.d0)),DIMENSION(:),POINTER  :: u, v
       REAL(KIND(0.d0)),DIMENSION(:),POINTER  :: wr, wi
       COMMON wr, wi
     END SUBROUTINE iffts1
  END INTERFACE
  INTERFACE
     SUBROUTINE ffts1(u,v)
       IMPLICIT NONE
       REAL(KIND(0.d0)),DIMENSION(:),POINTER :: u, v
       REAL(KIND(0.d0)),DIMENSION(:),POINTER :: wr, wi
       COMMON wr, wi
     END SUBROUTINE ffts1
  END INTERFACE
  INTERFACE
     SUBROUTINE fillroots(n)
       IMPLICIT NONE
       REAL(KIND(0.d0)),DIMENSION(:),ALLOCATABLE,SAVE  :: wwr, wwi
       REAL(KIND(0.d0)),DIMENSION(:),POINTER           :: wr, wi
       INTEGER :: n
       COMMON wr, wi
     END SUBROUTINE fillroots
  END INTERFACE
  INTERFACE
     SUBROUTINE fft1(x,y)
       IMPLICIT NONE   
       REAL(KIND(0.d0)),DIMENSION(:),POINTER  :: x,y
       REAL(KIND(0.d0)),DIMENSION(:),POINTER  :: wr, wi
       COMMON wr, wi
     END SUBROUTINE FFT1
  END INTERFACE
  INTERFACE
     SUBROUTINE ifft1(x,y)
       IMPLICIT NONE
       REAL(KIND(0.d0)),DIMENSION(:),POINTER  :: x,y
       REAL(KIND(0.d0)),DIMENSION(:),POINTER  :: wr, wi
       COMMON wr, wi
     END SUBROUTINE ifft1
  END INTERFACE
  INTERFACE 
     SUBROUTINE tpzdft(t)
       IMPLICIT NONE
       REAL(KIND(0.d0)), DIMENSION(:), POINTER       :: t
     END SUBROUTINE tpzdft
  END INTERFACE
  INTERFACE
     SUBROUTINE ldft(low,tlow)
       IMPLICIT NONE
       REAL(KIND(0.d0)), DIMENSION(:), POINTER       :: low, tlow
     END SUBROUTINE ldft
  END INTERFACE
  INTERFACE
     SUBROUTINE convs(u,v,a)
       IMPLICIT NONE
       REAL(KIND(0.d0)), DIMENSION(:), POINTER       :: u, v, a
     END SUBROUTINE convs
  END INTERFACE
END MODULE fft_interface

MODULE tdft_interface
  INTERFACE
     SUBROUTINE l_uzj(v,w,tw)
       REAL(KIND(0.d0)) :: v
       REAL(KIND(0.d0)), DIMENSION(:), POINTER :: w,tw
     END SUBROUTINE l_uzj
  END INTERFACE
  INTERFACE
     SUBROUTINE l_lzj_u(v,w,tw1,tw2)
       REAL(KIND(0.d0)), DIMENSION(:), POINTER :: w, tw1, tw2
       REAL(KIND(0.d0)) :: v
     END SUBROUTINE l_lzj_u
  END INTERFACE
  INTERFACE
     SUBROUTINE l_lzj(v,w,tw1)
       REAL(KIND(0.d0)):: v
       REAL(KIND(0.d0)), DIMENSION(:), POINTER :: w, tw1
     END SUBROUTINE l_lzj
  END INTERFACE
  INTERFACE
     SUBROUTINE ttrasp(s,w)
       REAL(KIND(0.d0)), DIMENSION(:), POINTER :: s, w
     END SUBROUTINE ttrasp
  END INTERFACE
END MODULE tdft_interface












